﻿Imports System.ComponentModel

Public Class Form1

    Const ConstEnableGradientColumnHeader As String = "EnableGradientColumnHeader"
    Const ConstDisableGradientColumnHeader As String = "DisableGradientColumnHeader"
    Const ConstEnableFiltering As String = "Enable Filtering"
    Const ConstDisableFiltering As String = "Disable Filtering"

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        TypeIntFlaggedDataGridViewExNumericTextBoxColumn1.Enum = GetType(TypeInt32FlaggedEnum)
        Try
            Helper.CreateRandomData(Me.TestDatenDataSet.TestDataTypes, 10)
            Dim rnd As New Random
            Dim arr = [Enum].GetNames(GetType(TypeInt32FlaggedEnum))
            For Each row As TestDatenDataSet.TestDataTypesRow In Me.TestDatenDataSet.TestDataTypes
                Dim value = Helper.RandomDecimal(rnd, 0, arr.Length, 0)
                If value = 0 Then
                    row.SetTypeIntFlaggedNull()
                Else
                    value -= 1
                    row.TypeIntFlagged = CInt(System.Enum.Parse(GetType(TypeInt32FlaggedEnum), arr(CInt(value))))
                End If
            Next
        Catch ex As Exception
            Stop
        End Try
        For Each col As DataGridViewColumn In Me.DataGridViewEx1.Columns
            col.AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells
        Next
        Me.btnGradientColumnHeader.Text = ConstDisableGradientColumnHeader
        Me.btnEnableFiltering.Text = ConstDisableFiltering
    End Sub

    Private Sub btnGradientColumnHeader_Click(sender As Object, e As EventArgs) Handles btnGradientColumnHeader.Click
        Me.DataGridViewEx1.GradientColumnHeader = Not Me.DataGridViewEx1.GradientColumnHeader
        If Me.DataGridViewEx1.GradientColumnHeader Then
            Me.btnGradientColumnHeader.Text = ConstDisableGradientColumnHeader
        Else
            Me.btnGradientColumnHeader.Text = ConstEnableGradientColumnHeader
        End If
    End Sub

    Private Sub btnEnableFiltering_Click(sender As Object, e As EventArgs) Handles btnEnableFiltering.Click
        Me.DataGridViewEx1.AllowFilter = Not Me.DataGridViewEx1.AllowFilter
        If Me.DataGridViewEx1.AllowFilter Then
            Me.btnEnableFiltering.Text = ConstDisableFiltering
        Else
            Me.btnEnableFiltering.Text = ConstEnableFiltering
        End If
    End Sub

End Class

<Flags>
Public Enum TypeInt32FlaggedEnum
    Eins = 1
    Zwei = 2
    Vier = 4
    Acht = 8
    Sechzehn = 16
End Enum